Name:		hp-ixgbe
Version:	5.13.4
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -f %{SOURCE1} -x %flav -b}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
Group: System/Kernel

%description KMP
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override ixgbe * weak-updates/%{name}" > %{name}.conf
echo "add_drivers+=\" ixgbe \"" > %{name}-oob.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/ixgbe.7 > source/ixgbe.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/ixgbe.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/ixgbe.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

install -d %{buildroot}%{_sysconfdir}/dracut.conf.d/
install %{name}-oob.conf %{buildroot}%{_sysconfdir}/dracut.conf.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/ixgbe.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/dracut.conf.d/%{name}-oob.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/ixgbe.7.gz
%doc source/COPYING source/README

%changelog
* Thu Mar 04 2021 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.11.3-1
- Fix potential memory leak

* Fri Sep 4 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.9.3-1
- This driver add support for new mailbox communication between PF and VF

* Mon Aug 10 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.8.1-1
- Add SLES15 SP2 support

* Fri May 15 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.7.1-1
- IPv6 support for ixgbe driver

* Mon Apr 6 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.7.0-1
- This driver use macro to handle change in nd_tx_timeout.

* Wed Sep 24 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.6.4-1
- This driver fixes an issue of Infinite recursion in device shutdown path due to a corner case when PCIe link was down
- Fix the issue of typo in ethtool stats
- Added RHEL7u7 Support.
- Added RHEL8 Support.
- Added SLES15SP1 Support.

* Tue Mar 12 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.5.5-1
- This driver fixes the issue when configuring MTU on VF in Guest OS would be failed.

* Mon Dec 10 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.5.2-1
- Added RHEL7u6 Support.
- Added SLES12SP4 Support.

* Wed Aug 08 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.7-0[rhel6.10, rhel7u5], 5.3.5.1-8[For other OSs]
- Added RHEL6.10 Support.
- Added RHEL7.5 Support.

* Thu Jul 26 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.1-8
- This driver fixes the Spectre/Meltdown issue.
- Added SLES15 Support.

* Wed May 16 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.1-5
- This driver updated the kernel version infor for SLES12sP3

* Mon Nov 06 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.3-1
- This driver updated branding strings from HP to HPE for legacy adapters 
- This driver fixes the issue of Unable to automatically get link after swapping SFP+ modules of different speeds 
- This driver fixes the issue of IPV6 magic packet can't wake up
- This driver fixes the issue of unable to set MTU value more than 1500 in SUSE12SP3 with Intel NICs
- This driver fixes linux Kernel panic occurs when assigning an IP address on HVL system with non existing PHY

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.2.1-4.rhel7u4
- Added support for HPE Ethernet 10Gb 2-port 562FLR-T Adapter
- Added support for HPE Ethernet 10Gb 2-port 562T Adapter
- Added SLES12SP3 support
- Added RHEL 7.4 support
- Fix the issue of sriov_totalvfs reporting incorrect number of supported VFs
- Fix the issue of RHEL6.9 64 bit is not able to create Virtual Functions with the sysfs command

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.0.7-2[rhel6u9], 5.0.7-1[For other OSs]
- Added SLES12SP2 support
- Added RHEL 7.3 support
- Fix the issue of Vlan interface in RHEL 6.8 VM on RHEL6.8 host fails to get IP
- Fix the issue of PHY stack trace and OS crash creating / allocating VFs.
- Fix the issue of Transmit queue stuck [DCB enabled]
- Fix the issue of NULL pointer dereference when enabling SRIOV
- Fix the issue of cannot set MACVLAN if MAC is set by PF, when VF is trusted

* Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.4.6-1
- Added RHEL 6.8 support
- Fix the issue of unable to dynamically detect SFP module
- Added support for Marvell PHY devices
- Added new netdev operation to trust the Virtual Function
- Added support to check and set the RSS hash and indirection table via ethtool -x/-X parameters	
- Added new netdev op to allow user to enable/disable the ability of a specific VF to query its RSS Indirection Table and an RSS Hash Key
- Fix the issue of packets being dropped as spoofed packets in SR-IOV mode
- Fix the issue of macvlan interfaces not being able to get link, ixgbevf parent loses link
- Fix the issue of ixgbe installation getting corrupted the system's ability to boot from SLES11SP4

* Wed Apr 13 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups
.hp.com> 4.3.13-2
 - Fix the issue of First Virtual Function(VF) receiving a copy of Physical Function(PF)'s traffic
 - Added support for Multicast promiscous mode for trusted Virtual Functions
